/***************************************************************************
 *            gtkdatabox_marker.h
 *
 *  Copyright  2005  J.C.Remis & Dr. Roland Bock
 ****************************************************************************/
/* GtkDatabox - An extension to the gtk+ library
 * Copyright (C) 1998 - 2005  Dr. Roland Bock
 */
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _GTKDATABOX_MARKER_H
#define _GTKDATABOX_MARKER_H

#include <gtkdatabox_text.h>

#ifdef __cplusplus
extern "C"
{
#endif

   typedef enum 
   {
      GTK_DATABOX_MARKER_N    = 0, /* marker north of data */
      GTK_DATABOX_MARKER_E,        /* marker east  of data */
      GTK_DATABOX_MARKER_S,        /* marker south of data */
      GTK_DATABOX_MARKER_W,        /* marker west  of data */
   } 
   GtkDataboxMarkerPosition;
   
   typedef enum
   {
      GTK_DATABOX_MARKER_TRIANGLE = 0, /* Marker is a triangle */
      GTK_DATABOX_MARKER_SOLID_LINE,   /* Marker is a solid line */
      GTK_DATABOX_MARKER_DASHED_LINE,  /* Marker is a dashed line */
   }
   GtkDataboxMarkerType;
   
   typedef struct 
   {
      GtkDataboxMarkerPosition position;       /* relative to data point */
      GtkDataboxMarkerType type;               /* type of the marker */
      PangoLayout *label;                      /* the label for marker */
      GtkDataboxTextPosition label_position;   /* position relative to marker */
      gboolean boxed;                          /* label in a box? */
   }
   GtkDataboxMarker;

   void
   gtk_databox_marker_draw (GtkDatabox * box, GtkDataboxData * data);
   
   void
   gtk_databox_marker_cleanup (GtkDatabox * box, GtkDataboxData * data);
   
   gint 
   gtk_databox_marker_set_markers (GtkDatabox * box, gint index, 
                                   GtkDataboxMarker *markers, gint length);
   gint 
   gtk_databox_marker_get_markers (GtkDatabox * box, gint index, 
                                   GtkDataboxMarker **markers, gint * length);
   
#ifdef __cplusplus
}
#endif

#endif /* _GTKDATABOX_MARKER_H */
